import { CancelOptions } from './utils';
interface RetryerConfig<TData = unknown, TError = unknown> {
    fn: () => TData | Promise<TData>;
    onFail?: (failureCount: number, error: TError) => void;
    onPause?: () => void;
    onContinue?: () => void;
    retry?: RetryValue<TError>;
    retryDelay?: RetryDelayValue;
}
export declare type RetryValue<TError> = boolean | number | ShouldRetryFunction<TError>;
declare type ShouldRetryFunction<TError = unknown> = (failureCount: number, error: TError) => boolean;
export declare type RetryDelayValue = number | RetryDelayFunction;
declare type RetryDelayFunction = (failureCount: number) => number;
export declare class Retryer<TData = unknown, TError = unknown> {
    cancel: (options?: CancelOptions) => void;
    continue: () => void;
    failureCount: number;
    isPaused: boolean;
    isResolved: boolean;
    isTransportCancelable: boolean;
    promise: Promise<TData>;
    constructor(config: RetryerConfig<TData, TError>);
}
export {};
